function Create(self)
    self.LTimer = Timer();
	self.isAttached = false;
	self.target = self.ID;
	self.target1 = self.ID;
	self.target2 = self.ID;
	self.pushstrength = 120;
end

function Update(self)
	if (self.isAttached == true) then
		--Check if target still exists
		if (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle)*10,math.sin(self.RotAngle)*-10), self.ID, 0, true, 1) == self.targetID) or (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle+0.22)*10,math.sin(self.RotAngle+0.22)*-10), self.ID, 0, true, 1) == self.targetID) or (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle-0.22)*10,math.sin(self.RotAngle-0.22)*-10), self.ID, 0, true, 1) == self.targetID) then
			--Everything normal, proceed as planned (section at the end)
		else
			--We're free like the wind! Time to reorient ourselves. Alternatively, kill ourselves. :)
			--ConsoleMan:PrintString("I've detached.. :(");
			--ConsoleMan:PrintString(tostring(self.RotAngle));
			self.isAttached = false;
			self.target = self.ID;
   			self:GibThis(Vector(0,0),0,self.parent)
		end
	end
	if (self.isAttached == false) then
		--Cast a short MORay in front of the projectile
		self.target = SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle)*10,math.sin(self.RotAngle)*-10), self.ID, 0, true, 1);
		self.target1 = SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle+0.22)*10,math.sin(self.RotAngle+0.22)*-10), self.ID, 0, true, 1);
		self.target2 = SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle-0.22)*10,math.sin(self.RotAngle-0.22)*-10), self.ID, 0, true, 1);
		if not (self.target1 == NOMOID) and not (self.target1 == self.ID) then
			self.target = self.target1;
		end
		if not (self.target2 == NOMOID) and not (self.target2 == self.ID) then
			self.target = self.target2;
		end
		--Check if the ray hit anything
		if not (self.target == NOMOID) and not (self.target == self.ID) then
			--Filter out particles like MOPixels and MOSParticles - we're aiming at actors and items
			--if (MovableMan:IsOfActor(self.target)) or (MovableMan:IsDevice(MovableMan:GetMOFromID(self.target))) then
				--The target is valid, begin attaching
				--Store target MOID
				self.targetID = self.target;
				--Store target pointer
				self.target = MovableMan:GetMOFromID(self.targetID);
				--Store location difference to target
				self.Dif = self.target.Pos - self.Pos;
				--Store angle difference between target rotation and offset vector rotation
				self.RelA = self.Dif.AbsRadAngle - self.target.RotAngle;
				--Store rotation difference to target
				self.DifA = self.RotAngle - self.target.RotAngle;
				--Confirm attaching
				self.isAttached = true;
				--ConsoleMan:PrintString("I've attached! :D");
				--ConsoleMan:PrintString(tostring(self.RotAngle));
			--end
		end
	end

	if (self.isAttached == true) then
		--Check if target still exists
		if (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle)*10,math.sin(self.RotAngle)*-10), self.ID, 0, true, 1) == self.targetID) or (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle+0.22)*10,math.sin(self.RotAngle+0.22)*-10), self.ID, 0, true, 1) == self.targetID) or (SceneMan:CastMORay(self.Pos, Vector(math.cos(self.RotAngle-0.22)*10,math.sin(self.RotAngle-0.22)*-10), self.ID, 0, true, 1) == self.targetID) then
			--Apply proper angle
			self.RotAngle = self.target.RotAngle + self.DifA;
			--Shift position
			self.shiftAngle = self.target.RotAngle + self.RelA;
			self.Pos.X = self.target.Pos.X + math.cos(self.shiftAngle)*-1*self.Dif.Magnitude;
			self.Pos.Y = self.target.Pos.Y + math.sin(self.shiftAngle)*1*self.Dif.Magnitude;
			--Push target (alternatively, target's root MO)
			--self.target:AddAbsForce(Vector(math.cos(self.RotAngle)*self.pushstrength,math.sin(self.RotAngle)*-1*self.pushstrength), self.Pos);
			self.target:AddAbsImpulseForce(Vector(math.cos(self.RotAngle)*self.pushstrength,math.sin(self.RotAngle)*-1*self.pushstrength), self.Pos);
			--MovableMan:GetMOFromID(MovableMan:GetRootMOID(self.targetID)):AddAbsForce(Vector(math.cos(self.RotAngle)*120,math.sin(self.RotAngle)*-120), self.Pos);
		else
			--We're free like the wind! Time to reorient ourselves. Alternatively, kill ourselves. :)
			--ConsoleMan:PrintString("I've detached.. :(");
			--ConsoleMan:PrintString(tostring(self.RotAngle));
			self.isAttached = false;
			self.target = self.ID;
			self:GibThis();
		end
	end
  	if self.LTimer:IsPastSimMS(3000) then
   		self:GibThis(Vector(0,0),0,self.parent)
  	end
end



